# -*- coding: utf-8 -*-
#http://search.maven.org/remotecontent?filepath=org/python/jython-standalone/2.7-b1/jython-standalone-2.7-b1.jar
from burp import IBurpExtender
from burp import IIntruderPayloadGeneratorFactory
from burp import IIntruderPayloadGenerator

from java.util import List, ArrayList

import random


class BurpExtender(IBurpExtender, IIntruderPayloadGeneratorFactory):
  def registerExtenderCallbacks(self, callbacks):
    self._callbacks = callbacks
    self._helpers = callbacks.getHelpers()

    callbacks.registerIntruderPayloadGeneratorFactory(self)

    return

  def getGeneratorName(self):
    return "Generator danych BHP"

  def createNewInstance(self, attack): 
    return BHPFuzzer(self, attack)

class BHPFuzzer(IIntruderPayloadGenerator):
  def __init__(self, extender, attack):
    self._extender = extender
    self._helpers  = extender._helpers
    self._attack   = attack
    print "Fuzzer BHP zainicjowany"
    self.max_payloads = 1000
    self.num_payloads = 0

    return


  def hasMorePayloads(self):
    print "Wywoano funkcj hasMorePayloads."
    if self.num_payloads == self.max_payloads:
      print "Nie ma wicej adunkw."
      return False
    else:
      print "Jest wicej adunkw. Kontynuacja."
      return True


  def getNextPayload(self,current_payload):   

    # konwersja na acuch
    payload = "".join(chr(x) for x in current_payload)

    # wywoanie mutatora w celu zmienienia dania POST
    payload = self.mutate_payload(payload)

    # zwikszenie liczby prb fuzzingu
    self.num_payloads += 1

    return payload

  def reset(self):

    self.num_payloads = 0

    return

  def mutate_payload(self,original_payload):

    # wybierz prosty mutator albo wywoaj skrypt zewntrzny
    picker = random.randint(1,3)

    # wybiera losowe miejsce w adunku do zmiany
    offset  = random.randint(0,len(original_payload)-1)
    payload = original_payload[:offset]

    # prba ataku SQL injection
    if picker == 1:      
      payload += "'"      

    # prba ataku XSS
    if picker == 2:
      payload += "<script>alert('BHP!');</script>"; 

    # powtrzenie fragmentu oryginalnego adunku losow liczb razy
    if picker == 3:

      chunk_length = random.randint(len(payload[offset:]),len(payload)-1)
      repeater     = random.randint(1,10)

      for i in range(repeater):
        payload += original_payload[offset:offset+chunk_length]

    # dodanie pozostaych bitw adunku
    payload += original_payload[offset:]

    return payload
